#!/usr/bin/env node
"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = __importStar(require("react"));
const ink_1 = require("ink");
const ink_big_text_1 = __importDefault(require("ink-big-text"));
const repl_ns_1 = require("repl-ns");
const ink_form_1 = require("ink-form");
const ytdl_core_muxer_1 = __importDefault(require("ytdl-core-muxer"));
const fs_1 = __importDefault(require("fs"));
const main = (0, repl_ns_1.ns)('main', {
    Main: () => (React.createElement(ink_1.Box, { flexDirection: "column" },
        React.createElement(ink_1.Box, null,
            React.createElement(ink_big_text_1.default, { text: "YOUTUBE DOWNLOAD" })),
        React.createElement(ink_1.Box, null,
            React.createElement(ink_form_1.Form, { ...main().formProps(), onSubmit: obj => main().onDownload(obj) })))),
    formProps: () => ({
        form: {
            title: 'Please setup form for downloading video from Youtube',
            sections: [
                {
                    fields: [
                        {
                            type: 'string',
                            name: 'url',
                            label: 'Youtube URL',
                            regex: RegExp('^https://.*$'),
                        },
                        {
                            type: 'string',
                            name: 'path',
                            label: 'File location',
                            initialValue: `${process.cwd()}/video.mp4`,
                        },
                    ],
                },
            ],
        },
    }),
    onDownload(obj) {
        (0, ytdl_core_muxer_1.default)(obj.url).pipe(fs_1.default.createWriteStream(obj.path));
    },
});
(async () => {
    await main.ready;
    const Main = main().Main;
    (0, ink_1.render)(React.createElement(Main, null));
})();
